
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExpensesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.create(
            {
                id: data.id || undefined,
        
        category: data.category
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        expense_date: data.expense_date
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        tax_treatment: data.tax_treatment
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        reviewed_at: data.reviewed_at
        ||
        null
            ,
            
        review_notes: data.review_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await expenses.setMerchant( data.merchant || null, {
            transaction,
        });
        
        await expenses.setReceipt( data.receipt || null, {
            transaction,
        });
        
        await expenses.setEntered_by( data.entered_by || null, {
            transaction,
        });
        
        await expenses.setReviewed_by( data.reviewed_by || null, {
            transaction,
        });
        
        await expenses.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return expenses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const expensesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                category: item.category
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                expense_date: item.expense_date
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                tax_treatment: item.tax_treatment
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                reviewed_at: item.reviewed_at
            ||
            null
            ,
            
                review_notes: item.review_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const expenses = await db.expenses.bulkCreate(expensesData, { transaction });

        // For each item created, replace relation files
        

        return expenses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const expenses = await db.expenses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.expense_date !== undefined) updatePayload.expense_date = data.expense_date;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.tax_treatment !== undefined) updatePayload.tax_treatment = data.tax_treatment;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.reviewed_at !== undefined) updatePayload.reviewed_at = data.reviewed_at;
        
        
        if (data.review_notes !== undefined) updatePayload.review_notes = data.review_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await expenses.update(updatePayload, {transaction});

        
        
        if (data.merchant !== undefined) {
            await expenses.setMerchant(
              
              data.merchant,
              
              { transaction }
            );
        }
        
        if (data.receipt !== undefined) {
            await expenses.setReceipt(
              
              data.receipt,
              
              { transaction }
            );
        }
        
        if (data.entered_by !== undefined) {
            await expenses.setEntered_by(
              
              data.entered_by,
              
              { transaction }
            );
        }
        
        if (data.reviewed_by !== undefined) {
            await expenses.setReviewed_by(
              
              data.reviewed_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await expenses.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return expenses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of expenses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of expenses) {
                await record.destroy({transaction});
            }
        });


        return expenses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findByPk(id, options);

        await expenses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await expenses.destroy({
            transaction
        });

        return expenses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findOne(
            { where },
            { transaction },
        );

        if (!expenses) {
            return expenses;
        }

        const output = expenses.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.merchant = await expenses.getMerchant({
            transaction
        });
        
        
        output.receipt = await expenses.getReceipt({
            transaction
        });
        
        
        output.entered_by = await expenses.getEntered_by({
            transaction
        });
        
        
        output.reviewed_by = await expenses.getReviewed_by({
            transaction
        });
        
        
        output.organizations = await expenses.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.merchants,
        as: 'merchant',
        
        where: filter.merchant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.merchant.split('|').map(term => Utils.uuid(term)) } },
            {
              business_name: {
                [Op.or]: filter.merchant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.receipts,
        as: 'receipt',
        
        where: filter.receipt ? {
          [Op.or]: [
            { id: { [Op.in]: filter.receipt.split('|').map(term => Utils.uuid(term)) } },
            {
              source_channel: {
                [Op.or]: filter.receipt.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'entered_by',
        
        where: filter.entered_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.entered_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.entered_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reviewed_by',
        
        where: filter.reviewed_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reviewed_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reviewed_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.review_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'review_notes',
                        filter.review_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.expense_dateRange) {
                const [start, end] = filter.expense_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reviewed_atRange) {
                const [start, end] = filter.reviewed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reviewed_at: {
                    ...where.reviewed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reviewed_at: {
                    ...where.reviewed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            
            if (filter.tax_treatment) {
                where = {
                    ...where,
                tax_treatment: filter.tax_treatment,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.expenses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'expenses',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.expenses.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

